library molli;

export 'package:fluttermollie/src/mollieaddress.dart';
export 'package:fluttermollie/src/mollieorder.dart';
export 'package:fluttermollie/src/mollieproduct.dart';
export 'package:fluttermollie/src/mollieamount.dart';
export 'package:fluttermollie/src/molliecheckout.dart';
export 'package:fluttermollie/src/mollieorderstatus.dart';
export 'package:fluttermollie/src/molliecustomer.dart';
export 'package:fluttermollie/src/molliesubscription.dart';
export 'package:fluttermollie/src/mollieshipment.dart';
export 'package:fluttermollie/src/mollieorderline.dart';
export 'package:fluttermollie/src/molliepayment.dart';
export 'package:fluttermollie/src/mollieinvoice.dart';
export 'package:fluttermollie/src/mollieinvoiceline.dart';

import 'package:fluttermollie/src/mollieclient.dart';
import 'package:fluttermollie/src/mollieorder.dart';
import 'dart:async';
import 'package:flutter/services.dart';

MollieClient client = new MollieClient();

class Mollie {
  final klarnaPayNow = "sofort";
  final creditCard = "creditcard";
  final payPal = "paypal";
  final sepa = "branktransfer";
  final applePay = "applePay";
  final ideal = "ideal";

  static const MethodChannel _channel = const MethodChannel('mollie');

  /// Opens the browser to process the payment. Returns after payment is done.
  static Future<void> startPayment(String checkoutUrl) async {
    return await _channel
        .invokeMethod('startPayment', {"checkoutUrl": checkoutUrl});
  }

  static MollieOrderResponse _currentOrder;

  static MollieOrderResponse getCurrentOrder() => _currentOrder;

  static MollieOrderResponse setCurrentOrder(MollieOrderResponse order) =>
      _currentOrder = order;
}
