import 'package:fluttermollie/internal/invoicehandler.dart';
import 'package:fluttermollie/internal/orderhandler.dart';
import 'package:fluttermollie/internal/customerhandler.dart';
import 'package:fluttermollie/internal/subscriptionhandler.dart';
import 'package:fluttermollie/internal/paymenthandler.dart';

class MollieClient {
  String _apiKey;
  var headers;

  OrderHandler orders;
  CustomerHandler customers;
  SubscriptionHandler subscription;
  PaymentHandler payments;
  InvoiceHandler invoiceHandler;

  static final MollieClient _instance = MollieClient._internal();

  factory MollieClient() => _instance;

  MollieClient._internal();

  /// Sets the api key
  void init(String apiKey) {
    _apiKey = apiKey;

    headers = {
      "Content-Type": "application/json",
      "Authorization": "Bearer " + apiKey,
    };

    orders = OrderHandler(headers);
    customers = CustomerHandler(headers);
    subscription = SubscriptionHandler(headers);
    payments = PaymentHandler(headers);
    invoiceHandler = InvoiceHandler(headers);
  }
}
